﻿using System;
using System.Data.SqlClient;

namespace ServeiWeb
{
    public class Connexio
    {
        private SqlConnection _connexio = new SqlConnection();

        public SqlConnection ConnexioAct
        {
            get { return _connexio; }
        }

        public void ObrirConnexio()
        {

            System.Configuration.Configuration rootWebConfig =
            System.Web.Configuration.WebConfigurationManager.OpenWebConfiguration("/MyWebSiteRoot");

            System.Configuration.ConnectionStringSettings ConnectionString;

            if (0 < rootWebConfig.ConnectionStrings.ConnectionStrings.Count)
            {
                ConnectionString =
                    rootWebConfig.ConnectionStrings.ConnectionStrings["IncidenciesEnllumenat.MySettings.GestioIncidentalConnectionString"];

                _connexio.ConnectionString = ConnectionString.ToString();

                _connexio.Open();
            }
            else
            {
                throw new Exception("No existeix cadena de connexió.");
            }

        }

        public void Tancar()
        {
            _connexio.Close();
        }
    }
}