﻿using System.Data;
using System.Data.SqlClient;

namespace ServeiWeb
{
    public class GestorSql
    {
         private readonly Connexio _connexio = new Connexio();
    private SqlCommand _sqlCommand;
    private string _select;


    public DataSet ExecutarSql(string sTaula,
                                    string sCamps,
                                    string sFiltre = "",
                                    string sOrdre = "")
    {

      _connexio.ObrirConnexio();
      _select = "Select " + sCamps + " from " + sTaula;


      if (sFiltre != "")
      {
        _select = _select + " Where " + sFiltre;
      }

      if (sOrdre != "")
      {
        _select = _select + " Order by " + sOrdre;
      }

      SqlDataAdapter _sqlAd = new SqlDataAdapter(_select, _connexio.ConnexioAct);
      DataSet _dtSet = new DataSet();

      _sqlAd.Fill(_dtSet);

      _connexio.Tancar();

      return _dtSet;

    }

    public DataSet ExecutarSql(string select)
    {

      _connexio.ObrirConnexio();

      SqlDataAdapter _sqlAd = new SqlDataAdapter(select, _connexio.ConnexioAct);
      DataSet _dtSet = new DataSet();

      _sqlAd.Fill(_dtSet);

      _connexio.Tancar();

      return _dtSet;

    }

    public void Modificar(string sTaula, string sCampsValors, string sFiltre = "")
    {
      _connexio.ObrirConnexio();

      if (sFiltre != "")
      {
        sFiltre = " Where " + sFiltre;
      }


      _sqlCommand =
        new SqlCommand("Update " + sTaula + " set " + sCampsValors + sFiltre,
                       _connexio.ConnexioAct);

      _sqlCommand.ExecuteNonQuery();

      _connexio.Tancar();


    }

    public SqlDataReader ObtDataReader(string select)
    {
      _connexio.ObrirConnexio();

      SqlCommand _sqlCommand = new SqlCommand(select, _connexio.ConnexioAct);
      SqlDataReader _sqlDtReader = _sqlCommand.ExecuteReader();

      return _sqlDtReader;
      
    }

  }
}