﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;

namespace ServeiWeb
{
    [ServiceBehavior(Namespace = "ServeiWeb")]

    public class Incidencies : IOService
    {
        public Usuari GetTecnic(string sUsuari, string sClau)
        {
            Usuari usu = new Usuari();
            usu.Buscar(sUsuari, sClau);

            return usu;

        }

        public Boolean ActEstatInc(int CodInc, string estat, string sMotiuCancel = "")
        {
            Incidencia inc = new Incidencia();
            return inc.ActEstatInc(CodInc, estat, sMotiuCancel);

        }

        public List<Incidencia> GetIncPend(int idTecnic)
        {
            Incidencia inc = new Incidencia();
            return inc.IncidenciesPendTec(idTecnic);
        }

        public Boolean ExisteixConnexioServWeb()
        {
            return true;
        }        
    }
}
