﻿using System.Data;

namespace ServeiWeb
{
    public class Usuari
    {
        private const int ID_TEC = 3;

        private DataTable _dtUsu = new DataTable();
        private GestorSql _gestSql = new GestorSql();

        private int _idUsuari;
        private string _login;
        private string _nomComplet;

        private string _select;

        public int CodUsuari
        {
            get
            {
                return _idUsuari;
            }
            set
            {
                _idUsuari = value;
            }
        }
        public string Login
        {
            get
            {
                return _login;
            }
            set
            {
                _login = value;
            }
        }
        public string NomComplet
        {
            get
            {
                return _nomComplet;
            }
            set
            {
                _nomComplet = value;
            }
        }

        //Carega un usuari pel seu login i clau
        public void Buscar(string sUsuari, string sClau)
        {

            _select = "SELECT Usuaris.codUsuari As Codi, Usuaris.nom +' '+  Usuaris.cognoms as NomComp, " +
                    "Usuaris.login as Usuari " +
                    "FROM Usuaris INNER JOIN " +
                    "UsuariPerfil ON Usuaris.codUsuari = UsuariPerfil.codUsuari " +
                    "WHERE  UsuariPerfil.codPerfil=" + ID_TEC + " and " +
                    "Usuaris.login='" + sUsuari + "' and " + "Usuaris.password='" + sClau + "' ";

            _dtUsu = _gestSql.ExecutarSql(_select).Tables[0];

            //Comprovem si hi ha registres
            if (_dtUsu.Rows.Count > 0)
            {
                DataRow dr = _dtUsu.Rows[0];
                _idUsuari = (int)dr["Codi"];
                _login = (string)dr["Usuari"];
                _nomComplet = (string)dr["NomComp"];
            }
            else
            {
                _login = "";
                _idUsuari = 0;
                _nomComplet = "";
            }

        }
    }
}