﻿Partial Public Class RestablirContrasenya

    Public _usuari As String
    Private _gestSql As New GestorSql
    Private _taula As String
    Private _camps As String
    Private _filtre As String

    Private Sub btnSortir_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles BtnSortir.Click
        Me.Close()
    End Sub

    Private Sub btnAccedir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnAccedir.Click

        Dim restablir_contrasenya As RestablirContrasenya = New RestablirContrasenya

        'Valida l'usuari i la contrasenya introduïdes
        If DadesCorrectes() Then
            Try
                CanviarContrasenya()
                MessageBox.Show _
                      ("S'ha canviat la contrasenya", "Canvi de contrasenya", MessageBoxButton.OK, MessageBoxImage.Information)

                Me.Close()

            Catch ex As Exception
                MessageBox.Show _
                  (ex.Message, "Error de canvi de contrasenya", MessageBoxButton.OK, MessageBoxImage.Error)

            End Try
        End If

    End Sub

    'Comprova si s'ha introduït el nom d'usuari i la contrasenya
    Private Function DadesCorrectes() As Boolean

        DadesCorrectes = False

        'Busquem si la contrasenya antiga és la correcta
        If txtPasswordAct.Password <> usuariAct.Buscar_Password(_usuari) Then
            MessageBox.Show _
                 ("La contrasenya antiga és incorrecte", "Error de contrasenya", MessageBoxButton.OK, MessageBoxImage.Error)
            txtPasswordAct.Clear()
            txtPasswordAct.Focus()

            Exit Function

            'Comprovem si el password nou s'ha escrit igual les dues vegades
        ElseIf txtPasswordNew1.Password <> txtPasswordNew2.Password Then
            MessageBox.Show _
                 ("Les noves contrasenyes introduïdes han de ser iguals", "Error de contrasenya", MessageBoxButton.OK, MessageBoxImage.Error)
            txtPasswordNew1.Clear()
            txtPasswordNew2.Clear()
            txtPasswordNew1.Focus()

            Exit Function

            'Comprovem que la nova contrasenya no sigui igual a l'anterior
        ElseIf txtPasswordNew1.Password = txtPasswordAct.Password Or txtPasswordNew2.Password = txtPasswordAct.Password Then
            MessageBox.Show _
                 ("La nova contrasenya no pot ser igual a l'anterior", "Error de contrasenya", MessageBoxButton.OK, MessageBoxImage.Error)
            txtPasswordNew1.Clear()
            txtPasswordNew2.Clear()
            txtPasswordNew1.Focus()

            Exit Function
        End If

        DadesCorrectes = True

    End Function

    'Canvia la contrasenya de l'usuari
    Private Sub CanviarContrasenya()

        _taula = "Usuaris"
        _camps = "password='" & txtPasswordNew1.Password & "' "
        _filtre = "login='" & _usuari & "' "

        _gestSql.Modificar(_taula, _camps, _filtre)

    End Sub

End Class
