﻿Imports System.Data

Public Class Usuaris

    Private ReadOnly _gestSql As New GestorSql
    Private _dtUsuari As New DataTable

    Private _perfils As New UsuariPerfil

    Private _codUsuari As Integer
    Private _nom As String
    Private _cognoms As String
    Private _dni As String
    Private _data_alta As Date
    Private _data_baixa As Date
    Private _adreça As String
    Private _cp As String
    Private _mobil As String
    Private _telf As String
    Private _email As String
    Private _login As String
    Private _password As String
    Private _usuari_baixa As String

    Private _taula As String
    Private _camps As String
    Private _valors As String

    Private _campsValors As String

    Private _filtre As String
    Private _ordre As String

    Private _select As String


    Public Property codUsuari() As Integer
        Get
            Return _codUsuari
        End Get
        Set(ByVal value As Integer)
            _codUsuari = value
        End Set
    End Property

    Public Property Nom() As String
        Get
            Return _nom
        End Get
        Set(ByVal value As String)
            _nom = value
        End Set
    End Property

    Public Property Cognoms() As String
        Get
            Return _cognoms
        End Get
        Set(ByVal value As String)
            _cognoms = value
        End Set
    End Property

    Public Property Dni() As String
        Get
            Return _dni
        End Get
        Set(ByVal value As String)
            _dni = value
        End Set
    End Property

    Public Property Data_Alta() As Date
        Get
            Return _data_alta
        End Get
        Set(ByVal value As Date)
            _data_alta = value
        End Set
    End Property

    Public Property Data_Baixa() As Date
        Get
            Return _data_baixa
        End Get
        Set(ByVal value As Date)
            _data_baixa = value
        End Set
    End Property

    Public Property Adreça() As String
        Get
            Return _adreça
        End Get
        Set(ByVal value As String)
            _adreça = value
        End Set
    End Property

    Public Property Cp() As String
        Get
            Return _cp
        End Get
        Set(ByVal value As String)
            _cp = value
        End Set
    End Property

    Public Property Mobil() As String
        Get
            Return _mobil
        End Get
        Set(ByVal value As String)
            _mobil = value
        End Set
    End Property

    Public Property Telf() As String
        Get
            Return _telf
        End Get
        Set(ByVal value As String)
            _telf = value
        End Set
    End Property

    Public Property Email() As String
        Get
            Return _email
        End Get
        Set(ByVal value As String)
            _email = value
        End Set
    End Property

    Public Property Login() As String
        Get
            Return _login
        End Get
        Set(ByVal value As String)
            _login = value
        End Set
    End Property

    Public Property Password() As String
        Get
            Return _password
        End Get
        Set(ByVal value As String)
            _password = value
        End Set
    End Property

    Public Property Usuari_Baixa() As String
        Get
            Return _usuari_baixa
        End Get
        Set(ByVal value As String)
            _usuari_baixa = value
        End Set
    End Property

    Public Property Perfils() As UsuariPerfil
        Get
            Return _perfils
        End Get
        Set(ByVal value As UsuariPerfil)
            _perfils = value
        End Set
    End Property

    Public Function ObtenirUsuaris(Optional ByVal sFiltre As String = "") As DataTable

        _taula = "Usuaris"

        '_filtre = "data_baixa is null"
        _filtre = ""
        If sFiltre <> "" Then
            _filtre = "Where " & sFiltre
            '_filtre = _filtre & " and " & sFiltre
        End If

        _select = "SELECT distinct Usuaris.codUsuari,Usuaris.nom,Usuaris.cognoms,Usuaris.dni,Usuaris.tlf,Usuaris.login,Usuaris.data_baixa,Usuaris.usuari_baixa " & _
                  "FROM Usuaris INNER JOIN " & _
                  "UsuariPerfil ON Usuaris.codUsuari = UsuariPerfil.codUsuari INNER JOIN " & _
                  "Perfils ON Perfils.codPerfil = UsuariPerfil.codPerfil " & _
                  _filtre & " " & _
                  "ORDER BY Usuaris.nom, Usuaris.cognoms "

        _dtUsuari = _gestSql.ExecutarSql(_select).Tables(0)

        Return _dtUsuari

    End Function

    Public Function ObtenirUsuarisPerfil(ByVal idPerfil As Integer) As DataTable

        _taula = "Usuaris"

        _filtre = ""
        _filtre = _filtre & " and UsuariPerfil.codPerfil=" & idPerfil

        _select = "Select '' as codUsuari, '' as Empleat UNION " &
                  "SELECT u.codUsuari, u.nom +' '+ u.cognoms as Empleat " & _
                  "FROM Usuaris u INNER JOIN " & _
                  "UsuariPerfil up ON u.codUsuari = up.codUsuari " & _
                  "Where " & _filtre & " " & _
                  "ORDER BY  Empleat "

        _dtUsuari = _gestSql.ExecutarSql(_select).Tables(0)

        Return _dtUsuari

    End Function

    'Carrega un Usuari pel seu login i password
    Public Sub Buscar(ByVal sLogin As String, _
                      ByVal sPassword As String)

        _taula = "Usuaris "
        _camps = "*"
        _filtre = "login='" & sLogin & "' and " & "password='" & sPassword & "'"
        _ordre = "nom"

        _dtUsuari = _gestSql.ExecutarSql(_taula, _camps, _filtre, _ordre).Tables(0)

        'Comprobem si hi ha registres
        If _dtUsuari.Rows.Count > 0 Then
            Carregar()
        Else
            Buidar()
        End If

    End Sub

    'Busca un usuari pel seu login i retorna la seva contrasenya
    Public Function Buscar_Password(ByVal sLogin As String) As String

        Dim _contrasenya As String

        _taula = "Usuaris "
        _camps = "password"
        _filtre = "login='" & sLogin & "' "
        _ordre = "nom"

        _dtUsuari = _gestSql.ExecutarSql(_taula, _camps, _filtre, _ordre).Tables(0)

        'Comprobem si hi ha registres i retornem el password
        If _dtUsuari.Rows.Count > 0 Then
            _contrasenya = _dtUsuari.Rows(0)(0).ToString
        Else
            _contrasenya = ""
        End If

        Return _contrasenya

    End Function

    'Carrega un Usuari pel seu codi
    Public Sub Buscar(ByVal idUsuari As Integer)

        _taula = "Usuaris"
        _camps = "*"
        _filtre = "codUsuari=" & idUsuari

        _dtUsuari = _gestSql.ExecutarSql(_taula, _camps, _filtre).Tables(0)


        'Comprovem si hi ha registres
        If _dtUsuari.Rows.Count > 0 Then
            Carregar()
        Else
            Buidar()
        End If

    End Sub

    Private Sub Carregar()

        With _dtUsuari.Rows(0)
            _codUsuari = .Item("codUsuari")
            _nom = .Item("nom")
            _cognoms = .Item("cognoms")
            _dni = .Item("dni")
            _data_alta = .Item("data_alta")
            _adreça = IIf(IsDBNull(.Item("adreça")), "", .Item("adreça"))
            _cp = IIf(IsDBNull(.Item("cp")), "", .Item("cp"))
            _mobil = IIf(IsDBNull(.Item("mobil")), "", .Item("mobil"))
            _telf = .Item("tlf")
            _email = IIf(IsDBNull(.Item("email")), "", .Item("email"))
            _login = .Item("login")
            _password = .Item("password")
            _data_baixa = IIf(IsDBNull(.Item("data_baixa")), DATA_NULL, .Item("data_baixa"))
            _usuari_baixa = IIf(IsDBNull(.Item("usuari_baixa")), "", .Item("usuari_baixa"))

        End With

        CarregarPerfils()

    End Sub

    Private Sub Buidar()
        _codUsuari = 0
        _nom = ""
        _cognoms = ""
        _dni = ""
        _data_alta = DATA_NULL
        _adreça = ""
        _cp = ""
        _mobil = ""
        _telf = ""
        _email = ""
        _login = ""
        _password = ""
        _usuari_baixa = ""
        _data_baixa = DATA_NULL

    End Sub

    'Gravem les dades de l'usuari. 
    'Si el cod. usuari és 0 serà un alta nova i si és diferent de 0 serà una modificació
    Public Sub Gravar()

        _taula = "Usuaris"

        'Alta
        If _codUsuari = 0 Then

            _password = _login
            _camps = "nom,cognoms,dni,data_alta,adreça," & _
                      "cp,mobil,tlf,email,login,password,data_baixa,usuari_baixa "

            _valors = _
              "'" & _nom & "','" & _cognoms & "','" & _dni & "', " & _
              "'" & _data_alta & "'," & IIf(_adreça <> "", "'" & _adreça & "'", "Null") & ", " & _
              IIf(_cp <> "", "'" & _cp & "'", "Null") & ", " & _
              IIf(_mobil <> "", "'" & _mobil & "'", "Null") & ", " & _
             "'" & _telf & "', " & _
               IIf(_email <> "", "'" & _email & "'", "Null") & ", " & _
               "'" & _login & "','" & _password & "',Null,Null "

            _codUsuari = _gestSql.AfegirId(_taula, _camps, _valors)
        Else
            'Modificació 
            _filtre = "codUsuari=" & _codUsuari
            _campsValors = "nom='" & _nom & "', cognoms='" & _cognoms & "', " & _
            "dni='" & _dni & "',data_alta='" & _data_alta & "', adreça='" & _adreça & "', " & _
            "cp='" & _cp & "', mobil='" & _mobil & "', " & "tlf='" & _telf & "', email='" & _email & "', " & _
            "login='" & _login & "', data_baixa='" & IIf(DateTime.Compare(_data_baixa, DATA_NULL) = 0, _
                                                         "", _data_baixa) & _
            "' ,usuari_baixa='" & _usuari_baixa & "' "

            _gestSql.Modificar(_taula, _campsValors, _filtre)

        End If

        GravarPerfils()

    End Sub

    Public Sub Esborrar(ByVal idUsuari As Integer)

        _taula = "Usuaris"
        _camps = "data_baixa='" & DateTime.Now.Date & "', usuari_baixa='" & usuariAct.Login & "' "
        _filtre = "codUsuari=" & idUsuari
        _gestSql.Modificar(_taula, _camps, _filtre)

    End Sub

    Public Function DadaExistent(ByVal sCamp As String, _
                                  ByVal sValor As String) As Boolean

        Dim dtTemp As DataTable

        _taula = "Usuaris"
        _camps = sCamp
        _filtre = sCamp & "=" & sValor & " and codUsuari<>" & _codUsuari

        dtTemp = _gestSql.ExecutarSql(_taula, _camps, _filtre).Tables(0)

        'Comprovem si hi ha dades
        If dtTemp.Rows.Count > 0 Then
            Return True
        Else
            Return False
        End If

    End Function

    Private Sub GravarPerfils()
        _perfils.EsborrarPerfil(_codUsuari)
        GravarPerfilsTaula()
    End Sub

    Private Sub GravarPerfilsTaula()
        Dim codfilera As Integer

        For codfilera = 0 To _perfils.Count - 1
            _perfils.GuardarPerfil(_codUsuari, _perfils.Item(codfilera).codPerfil)
        Next

    End Sub

    Private Sub CarregarPerfils()
        Dim dtPer As DataTable
        Dim oPerf As Perfils
        Dim fila As Integer

        _select = "SELECT  p.codPerfil, p.perfil " & _
                  "FROM    UsuariPerfil up INNER JOIN " & _
                  "Perfils p ON up.codPerfil = p.codPerfil " & _
                  "where up.codUsuari=" & _codUsuari

        dtPer = _gestSql.ExecutarSql(_select).Tables(0)

        For fila = 0 To dtPer.Rows.Count - 1

            With dtPer.Rows(fila)
                oPerf = New Perfils(.Item("codPerfil"), .Item("perfil"))
                _perfils.Afegir_a_Col(oPerf)
            End With

        Next

    End Sub

    Public Function TePerfil(ByVal sPerfil As String) As Boolean
        Dim fila As Integer
        TePerfil = False

        For fila = 0 To _perfils.Count - 1
            If _perfils.Item(fila).Perfil = sPerfil Then
                TePerfil = True
            End If
        Next

        Return TePerfil
    End Function

    Public Sub AfegirPerfil(ByVal sPerfil As String)
        Dim oPerf As New Perfils

        If Not TePerfil(sPerfil) Then
            oPerf = New Perfils(oPerf.ObtenirCodPerfil(sPerfil), sPerfil)
            _perfils.Afegir_a_Col(oPerf)
        End If
    End Sub

    Public Sub EliminarPerfil(ByVal sPerfil As String)
        Dim fila As Integer
        Dim esborrat As Boolean

        fila = 0
        esborrat = False

        Do While fila < _perfils.Count Or esborrat = False
            If _perfils.Item(fila).Perfil = sPerfil Then
                _perfils.Esborrar_de_Col(fila)
                esborrat = True
            End If
            fila = fila + 1
        Loop
    End Sub

    Public Function EsBaixa() As Boolean

        Dim dtTemp As DataTable
        Dim _result As Boolean = False

        _taula = "Usuaris"
        _camps = "usuari_baixa"
        _filtre = "codUsuari=" & _codUsuari

        dtTemp = _gestSql.ExecutarSql(_taula, _camps, _filtre).Tables(0)

        'Comprovem la data de baixa
        If dtTemp.Rows(0)(0).ToString <> "" Then
                _result = True
        End If

        Return _result

    End Function

    'Ens retorna el llistat d'usuaris carregats al sistema segons el seu perfil
    Public Function ObtenirUsuariCbo(Optional ByVal sFiltre As String = "") As DataTable

        _filtre = ""

        If sFiltre <> "" Then
            _filtre = "and " & sFiltre & " "
        End If

        _select = "SELECT u.codUsuari, u.login " & _
                  "FROM Usuaris u INNER JOIN UsuariPerfil up " & _
                  "ON u.codUsuari = up.codUsuari " & _
                  "Where (u.usuari_baixa is null OR u.usuari_baixa='') " & _filtre & " " & _
                  "ORDER BY u.codUsuari, u.login "

        _dtUsuari = _gestSql.ExecutarSql(_select).Tables(0)

        Return _dtUsuari

    End Function

    Public Sub CanviarContrasenya(ByVal sLogin As String)

        _taula = "Usuaris"
        _filtre = "login='" & sLogin & "' "

        _campsValors = "password='" & sLogin & "' "

        _gestSql.Modificar(_taula, _campsValors, _filtre)

    End Sub

End Class
