﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration

Public Class Connexio

    Private ReadOnly _connexio As New SqlConnection

    Public ReadOnly Property ConnexioActiva() As SqlConnection
        Get
            Return _connexio
        End Get
    End Property

    Public Sub ObrirConnexio()

        Try

            'Llegim l'arxiu "app.config", per a obtenir la connexió
            _connexio.ConnectionString = _
              ConfigurationManager.ConnectionStrings("IncidenciesEnllumenat.MySettings.GestioIncidentalConnectionString").ConnectionString

            _connexio.Open()

        Catch e As Exception
            Throw New Exception(e.Message)
        End Try

    End Sub

    Public Sub TancarConnexio()
        _connexio.Close()
    End Sub

End Class
