﻿Imports System.Data

Module ModulGeneral

    Public usuariAct As Usuaris

    'Perfils Usuaris
    Public Const ID_ADM As Integer = 1
    Public Const ADM As String = "Administrador"

    Public Const ID_OFI As Integer = 2
    Public Const OFI As String = "Oficinista"

    Public Const ID_TEC As Integer = 3
    Public Const TEC As String = "Tecnic"

    'Estats Incidències
    Public Const INC_ESTAT_PEND As String = "PENDENT"
    Public Const INC_ESTAT_TANC As String = "TANCADA"
    Public Const INC_ESTAT_CANC As String = "CANCEL·LADA"

    Public Const DATA_NULL As String = "0:00:00"

    Public Sub NomesNumeros(ByRef sender As Object, ByRef e As KeyEventArgs)

        If (e.Key >= Key.D0 And e.Key <= Key.D9 Or e.Key >= Key.NumPad0 And e.Key <= Key.NumPad9) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub

    'Força a què el valor de la data de baixa sigui "" si és nul
    Public Sub CanviarDataBaixa(ByRef _taula As DataTable, ByRef _iColumnaDataBaixa As Integer, ByRef _iColumnaUsuariBaixa As Integer)

        Dim _dadesfila As DataRow = Nothing

        'Comparem la data de baixa. Si és igual a la data mínima (DateTime.MinValue), retornem "" per a què a la grid es vegi buit aquest valor

        For Each _dadesfila In _taula.Rows
            If Not IsDBNull(_dadesfila(_iColumnaUsuariBaixa)) Then
                If _dadesfila(_iColumnaUsuariBaixa).ToString = "" Then
                    _dadesfila(_iColumnaDataBaixa) = DBNull.Value
                End If
            End If
        Next
    End Sub

End Module
